#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define BLOCK_SIZE	256
#define BLOCK_COUNT	(1<<8)

int main(int argc,char *argv[]){
if(argc!=3){
  fprintf(stderr,"Syntax: %s <file> R|W\n",argv[0]);
  exit(EXIT_FAILURE);
  }
char *file=argv[1];
unsigned char mwrite=(argv[2][0]=='W')?1:0;
int fd=open(file,(mwrite?O_WRONLY:O_RDONLY));
if(fd<0){
  fprintf(stderr,"Cannot open '%s'\n",file);
  exit(EXIT_FAILURE);
  }
int i,j;
for(i=0;i<BLOCK_COUNT;i++){
  lseek(fd,i*BLOCK_SIZE,SEEK_SET);
  printf("%s block %d/%d [%d%%]\n",mwrite?"Writing":"Reading",i,BLOCK_COUNT,i*100/BLOCK_COUNT);
  for(j=0;j<BLOCK_SIZE;j++){
    unsigned char wbyte=i&0xff;
    if(mwrite){
      if(write(fd,&wbyte,1)!=1){
        fprintf(stderr,"Write error block #%d byte #%d\n",i,j);
        exit(EXIT_FAILURE);
        }
      }
    else{
      unsigned char rbyte;
      if(read(fd,&rbyte,1)!=1){
        fprintf(stderr,"Read error block #%d byte #%d\n",i,j);
        exit(EXIT_FAILURE);
        }
      if(rbyte!=wbyte){
        fprintf(stderr,"Bad byte %x!=%x, block #%d byte #%d\n",rbyte,wbyte,i,j);
        }
      }
    }
  if(mwrite) fsync(fd);
  }
close(fd);
return 0;
}
